<?php

  // --------------------------------------------------------------
  //                                                        chemins
  //

  $PATHES = array(

    // chemin HTTP de l'installation
    // (dossier, sur le site, qui contient le fichier index.php)
    // absolu a partir de la racine HTTP du site
    //
    // installation dans un dossier :
    // "web" => "/chemin/du/dossier"
    //
    // installation a la racine :
    "web" => "/",

    // chemin HTTP du dossier "mw"
    // absolu a partir de la racine HTTP du site
    "mw_path" => "/mw",

    // chemin du dossier "mw" sur le systeme d'exploitation
    // relatif au dossier de l'installation
    // ou absolu dans le systeme de fichiers
    "mw_dir" => "mw",

    // dossier des contenus editables par l'application
    // relatif au dossier de l'installation
    "content" => "content"
  );

  // --------------------------------------------------------------
  //                                                base de donnees
  //

  // mtweb propose deux modes de stockage des donnees
  //
  //  - dans des fichiers XML
  //
  //  - ou en utilisant un gestionnaire de base de donnees SQL
  //
  // ci-dessous deux exemples de configurations pour la connexion
  // une pour XML (par defaut) et l'autre pour MySql (commentee)

  // --------------------------- XML

  $bdd = array(
    // on utilise stockage de donnees dans des fichiers XML
    "sgbd" => "xml",
    // les fichiers XML sont enregistres dans le repertoire :
    "host" => "content/data/xml",
    // dans ce repertoire, la base de donnees est dans le dossier :
    "base" => "mw"
  );

/*
  // --------------------------- MYSQL
  //
  // pour utiliser MySql, importez la base de donnees :
  //
  //    mysql -u mysql_user -p < content/data/mysql/mtweb.sql
  //
  // et remplacez avec vos parametres de connexion :

  $bdd = array(
    // on utilise MySql avec PDO (driver pdo_mysql)
    "sgbd" => "pdo_mysql",
    // hote du serveur MySql
    "host" => "localhost",
    // nom de la base de donnees
    "base" => "mtweb",
    // prefixe pour les noms des tables (*)
    "table_prefix" => "mw_",
    // identification pour la connexion sur le serveur MySql
    "user" => "mysql_user",
    "password" => "mysql_password"
  );

  // (*) le script mtweb.sql cree les tables avec le prefixe mw_
  // adaptez le script si vous utiliez un autre prefix
*/

?>